
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>从0开始打造一个独立内存的缓存系统 / iVAN</title>

    <meta name="description" content="从0开始打造一个独立内存的缓存系统 前言 缓存是后端使用得最多的东西,因为性能是后端开发一个重要的特征,所以缓存就应运而生了,而且现在缓存已经到了泛滥的程度了,我几乎没见过没有缓存的后端,一遇到性能问题,首先想到的不是看代码,而是加缓存,我也是醉了,好了,不扯这些,这些和今天的文章无关,今天我们来专门讲讲缓存吧. 2缓存和KVDB 缓存和KVDB两个东西经常一起出现,两者在使用上没有明显的界限,当一个KVDB速度够快,性能够强劲,那么就可以当缓存来用了,我们使用Redis来做缓存,实际上就是把一个KVDB来当缓存用.但一般情况下,">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">从0开始打造一个独立内存的缓存系统</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><b><br /></b></p>
<h2>前言</h2>
<p>缓存是后端使用得最多的东西，因为性能是后端开发一个重要的特征，所以缓存就应运而生了，而且现在缓存已经到了泛滥的程度了，我几乎没见过没有缓存的后端，一遇到性能问题，首先想到的不是看代码，而是加缓存，我也是醉了，好了，不扯这些，这些和今天的文章无关，今天我们来专门讲讲缓存吧。</p>
<h2>2缓存和KVDB</h2>
<p>缓存和KVDB两个东西经常一起出现，两者在使用上没有明显的界限，当一个KVDB速度够快，性能够强劲，那么就可以当缓存来用了，我们使用Redis来做缓存，实际上就是把一个KVDB来当缓存用。但一般情况下，KVDB能提供更多的数据结构，所以象Redis这样的KVDB中有很多实用的数据结构，比如List啊，hashtable啊之类的，而且KVDB一般都提供持久化的存储，而像memcached这样的纯缓存一般不提供持久化存储功能，而且数据结构也比较简单，仅仅提供key和value都是字符串的形式。</p>
<p>现在KVDB的代表Redis性能已经越来越强劲了，虽然它是个单线程的服务，但目前基本上能用memcached的都可以用Redis代替，而且Redis因为支持更多的数据结构，所以扩展性更好。现在很多情况下所说的缓存，实际上都是指的是Redis缓存。</p>
<h2>3缓存的类型</h2>
<p>我们这里抛开Redis，来单独说说缓存，所谓缓存，实际上是为了给数据提供一个更快的访问方式，这个更快一般是相对于最终数据而言的，最终数据可以是KVDB中的数据，也可以是文件数据，还可以是其他机器上的数据库数据，只要比这些个数据访问的快的，都可以叫缓存，那么一般缓存分成一下几种。</p>
<ul>
<li>数据库型缓存，比如最终数据是其他机器上的MySQL数据库中，那么我们做一个KVDB的数据库，查询的时候按照key查询，总比数据库要快点吧，那这个KVDB就是个缓存。</li>
<li>文件型的缓存，进一步说，远程的KVDB还是有网络延迟，慢了点，这时候我在本地做一个文件缓存，这个文件的访问速度比远程数据库要快吧，那这个文件也是个缓存。</li>
<li>内存型的缓存，再进一步，本地文件还是嫌慢了，那么我们再做一个内存缓存，把最热的数据存到内容中，那这个内存的访问速度一定比文件要快，那这个内存块也是个缓存。</li>
</ul>
<p>所以说，只要比最终数据访问得快的数据结构，就是一个缓存系统。</p>
<p>为了一般性，我们这里所说的缓存，将会说一个内存型的缓存，只提供简单字符串类型的key和value的操作。</p>
<h2>4如何设计一个缓存</h2>
<p>设计一个独立的内存型的缓存系统，首先先要确定缓存最关心的东西，那就是性能，所有的需要考虑的东西都是围绕性能两个字来进行设计的，所以最重要的部分，设计一个缓存需要考虑以下三个方面，底层数据结构，内存管理，网络模型。</p>
<p>  底层数据结构<br />
<br />又看到数据结构这个词了，我们所说的所有轮子，都跑不掉数据结构这个东西，对于缓存来说，一般都是KV形式的数据结构，所以底层一般会使用树或者哈希表来保存数据，而缓存对性能的要求更高，所以一般使用哈希表来保存数据，所以底层的数据结构就是哈希表了。</p>
<p>  哈希表<br />
   哈希函数和类型<br />
<br />选择哈希表，是因为它的O(1)的查询复杂度，这是一个很重要的性能指标，但如果哈希函数没有选择好，产生了大量的哈希碰撞，那性能就会急剧降低，所以对于哈希函数的选择也是一个需要考虑的问题，比较流行的哈希函数有很多，特别的，如果是自用型的缓存，哈希函数可以根据业务场景再来调整，保证哈希的均匀，从而让查询复杂度更加接近O(1)。</p>
<p>哈希表的实现方式有很多中，最最基础的就是数组+链表的形式了，也叫开链哈希，数组长度就是哈希的桶的长度，链表用来解决冲突，插入数据的时候如果哈希碰撞了，把具体节点挂在该节点后面的链表上，查询数据时候有冲突，就继续线性查询这个节点下的链表。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZGJhcGx1cy5jbi91cGxvYWRmaWxlLzIwMTYvMDgxMi8yMDE2MDgxMjEwMTYwMDIyNC5qcGc=.jpg"> </p>
<p>还有一种叫闭链哈希，闭链哈希实际是一个循环数组，数组长度就是桶的长度，插入数据的时候有冲突的话，移动到该节点的下一个，直到没有冲突为止，如果移动到了末尾的话，转到数组的头部，查找数据的时候类似。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZGJhcGx1cy5jbi91cGxvYWRmaWxlLzIwMTYvMDgxMi8yMDE2MDgxMjEwMTYxNDkwMC5qcGc=.jpg"> </p>
<p>我们这里说的哈希表都是第一种开链哈希表。</p>
<p>   锁<br />
<br />由于缓存不仅仅有读，还有写操作，如果在多线程的场景下，势必会产生加锁的操作，如果设计这个锁也是需要考虑的，如果写操作不是很多的情况下，那么整个哈希表加读写锁就行了，但如果写操作也比较频繁，那么可以为一批哈希槽或者每一个哈希槽加一把锁，这样的话，可以把锁等待的时间延迟给降下来，具体还是要看场景，我实现的时候是给每个槽加了一个读写锁，这样更耗费内存，但是性能好一些。这种类型的哈希表的数据结构长成下面这个图的样子。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZGJhcGx1cy5jbi91cGxvYWRmaWxlLzIwMTYvMDgxMi8yMDE2MDgxMjEwMTYyMzk3Ny5qcGc=.jpg"></p>
<p>每一个槽配了一把读写锁，每次写的时候都对单个槽进行加锁操作，这样的坏处就是需要维护巨多无比的锁，容易造成浪费，在实际中我们可以根据实测的结果，给一批槽加一把锁，这样也可以把锁资源空下来，并且也能达到比较好的并发效果。</p>
<p>关于锁设计，再多说一下，多线程（或者多协程）的情况下，加锁是一种常规处理方式，现在的X86架构，支持一种CAS的无锁操作模式，是在CPU层面实现的对变量的多线程同步技术，golang中有个atomic包，简单的封装了这个功能，但是这个操作在进行变量更新的时候一般要在一个循环中来实现，不停的尝试直到成功为止，虽然说减少了锁的操作，但代码看起来没那么清晰，而且如果出了问题，调试起来也没有锁那么清晰，并且虽然是CPU级别的支持，但是还是有问题的，就是线程切换的时候还是会造成不可预知的错误，这里就不展开了，感兴趣的可以自己去搜索一下CAS无锁操作，并且在一般的缓存中还是读多写少，通过把锁扩展到槽级别基本上性能不会出现很大的损耗，当然，如果你对性能有着极致的追求，可以考虑CAS方案，但是也要注意坑哦。</p>
<p>   字符串和整数<br />
<br />最后，我们看看对于单个的具体的哈希槽，在发生哈希碰撞的时候一个槽下面可能挂了很多节点。</p>
<p>当进行读操作的时候，如果哈希到这个槽下面来了，我们需要比较每个节点的key和查询串的值，只有相等的情况才是我们需要的。比较每个key的值是进行了一次字符串的比较，效率是比较低的，这里继续出现一个用空间换时间的方法，就是我们在插入节点的时候给每个节点的key生成两个哈希值，第一个哈希值用来进行槽的选择，第二个哈希值保存在节点内，查询的时候不进行key的字符串比较而比较第二个哈希值，由于哈希值是整数的，所以比较效率比直接比较字符串要快多了。用这样的方式，在写入数据和查询数据的时候需要进行两次哈希计算，并且还需要有个单独的空间来存储第二个哈希值，但是查询的时候可以节省字符串比较的时间。</p>
<p>对于两个字符串的比较，平均时间复杂度是O(n/2)吧，而对于两个整数的比较，一个异或操作就搞定了，谁快就不用说了吧，这个槽变成这样了。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZGJhcGx1cy5jbi91cGxvYWRmaWxlLzIwMTYvMDgxMi8yMDE2MDgxMjEwMTYzMzczMC5qcGc=.jpg"></p>
<p>   重哈希(reHash)<br />
<br />对于不断增长的数据而言，重哈希是一个必不可少的过程，所谓重哈希，就是当你的桶使用到一定程度以后碰撞的概率就变很大了，这时候就需要把桶加大了。</p>
<p>把桶加大，必然需要进行一次重新哈希的过程，这个过程的处理办法也有一些技巧。</p>
<ol>
<li>直接重新哈希，这是最简单的，就是把所有的key重新哈希一遍放到新的桶中，简单粗暴，但是缺点也很明显，就是当key很多的时候非常耗时间和资源，在这段时间中，服务是不可用的。</li>
<li>逐步迁移的重哈希，因为桶的变化，重新哈希是无法避免的，这时候我们主要要考虑的是让服务尽可能的保持可用，那么除了直接哈希，还有一种策略上的优化，简单的描述就是申请两个桶A和B，B的桶数量大于A</li>
<li>初始化申请的时候可以并不实际申请内存空间，首先用第一个桶A进行数据存储，当第一个桶A使用到一定比例，比如80%的时候，开始进行哈希迁移。</li>
</ol>
<ul>
<li>新来的写操作先哈希到桶B，然后在哈希到桶A上，把A桶上命中的节点上的所有数据重新哈希到B上，然后在A上打一个标记，表示这个节点失效了。</li>
<li>新来的读操作，先哈希到A进行命中，如果A的这个节点标记为失效，再哈希到B上读取正确数据，如果A节点没有标记失效，那么把这个节点下的所有数据重新哈希到B上，并在A上打一个标记，表示这个节点失效了。</li>
<li>直到所有的A的数据都迁移完成，把A和B交换一下，并且把A的桶数据增加，作为下一次迁移使用。</li>
</ul>
<p>这样，当进行重新哈希的时候，多了几次哈希运算，性能损失了一些，但是服务始终是可用的。</p>
<p>   内存管理<br />
<br />还有一个方面就是内存了，因为有写操作，那么就需要申请内存，如果写操作比较多的话，再加上有删除操作的话，那就会不停的申请释放内存。内存的申请和释放也是比较损耗性能的，所以一般会用自己的内存池来进行内存的分配。关于内存池这一块，有很多内存池的实现方式，这里就不详细说了。</p>
<p>其实我觉得这种对性能有强要求的服务，不太适合使用带GC的语言进行编写，最直接的还是用C这种系统语言来编写，特别是涉及到内存池这种比较靠底层的东西，有GC实际上是很麻烦的事情，在Golang中，因为是自带GC的，如果需要进一步榨干系统的性能，那么这么底层的东西要用CGO来实现了，把GC丢一边，所有的内存都自己管。</p>
<p>   网络模型<br />
<br />除了在底层数据结构层的性能损耗外，网络模型的选择也是很重要的，选择性能尽可能高的网络模型也能极大的提升性能，比如memcached就用了libevent这个事件模型，总的来说就是先通过一个主线程监听端口，接收到网络文件描述符以后，然后通过master-worker这种结构将网络的套接字分发到各个worker线程的独立队列中，各个线程利用libevent模型对队列中的套接字进行读写。</p>
<p>而Redis的网络模型更简明一点，但也是基于epoll的IO多路复用，感兴趣的朋友可以自己去看看Redis的源码，它相当于是一个稍微简化版本的libevent模型。</p>
<p>关于libevent和libev这两个模型（其实差不太多），我们可以专门写一篇文章分析一下源码，它们的源码都不多，正好我也看过，可以写一篇文章，当然网上这类文章也很多。</p>
<p>对于网络模型，实际上现代的高级语言已经基本上封装到http这个层次了，比如golang这种现代语言，http的包都可以直接用，并且并发性能也挺好的，但是对于一个缓存系统，如果配合一个http的模型，就显得太重了，http底下的TCP模型就可以很好的解决问题，对于这一块，我们可以用个简单的模型：</p>
<ul>
<li>根据CPU的核心数启动相应数量的协程，每个协程配合一个channel</li>
<li>启动一个协程负责接收tcp连接，accpet链接以后通过channel交给相应的协程处理</li>
</ul>
<p>这段代码虽然使用了channel这个东西，但也算是一个比较标准的多线程编程方式了，在多线程的世界中也可以用循环链表来表示这个channel，用代码来体现大概就是这样子的。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZGJhcGx1cy5jbi91cGxvYWRmaWxlLzIwMTYvMDgxMi8yMDE2MDgxMjEwMTY0NDYzMS5wbmc=.jpg"></p>
<p>除了上面那种模型，还有一种比较奔放的模型，也是比较golang的写法了。</p>
<ul>
<li>启动一个协程负责接收tcp连接，accpet链接以后go出一个协程进行处理</li>
</ul>
<p>代码实现就是下面这个样子</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZGJhcGx1cy5jbi91cGxvYWRmaWxlLzIwMTYvMDgxMi8yMDE2MDgxMjEwMTY1NTMzNy5wbmc=.jpg"></p>
<p>   关于golang的协程分析<br />
<br />这种奔放的协程使用方式到底行不行？这两种到底哪个比较好？这里我们不讨论这两种模型哪种好，我们看看golang的协程吧。golang的协程网上资料很多，关于协程的详细设计可以找到不少文章，总的来说就是这是一个轻量级的线程，有多轻呢？轻到它其实就是一个代码段加上一个自己的栈，光这个还不够，线程也可以说是一个代码片段加上一个自己的栈，只是协程的栈比线程的小而已，除了这个以为，协程主要的轻表现在它不通过操作系统调度，它是通过代码内部进行显示调度的。</p>
<p>什么叫代码内部进行显示调度呢？</p>
<p>我们先看看目前流行的两个事件模型（同时也是处理网络连接的网络模型），一种是nodejs为代表的IO模型，大堆回调函数，一种是传统的多线程模型。</p>
<p>先看回调模型，像下图一样，左边是IO队列，右边是代码片段，每个IO事件对应一个回调函数，接收到IO事件以后进行相应的函数处理，这样的好处就是CPU利用率极高，不用切换资源，坏处就是代码被扯乱了，变成无序的了，对编程的要求比较高。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZGJhcGx1cy5jbi91cGxvYWRmaWxlLzIwMTYvMDgxMi8yMDE2MDgxMjEwMTcwNTczMy5qcGc=.jpg"></p>
<p>再看看线程模型，线程模型线程的切换实际上是操作系统来进行的，线程模型如下图，右边是线程的代码，左边的舞台就是CPU了，当在CPU上跳舞的线程进行系统调用（比如读取文件）或者每隔一段时间（时钟中断，不了解的请自行看计算机体系结构），操作系统就会把当前在CPU上玩耍的线程换下来，换个新的上去，这样的调度方式是操作系统来进行的，不需要线程本身参与，线程什么时候运行完全有操作系统说了算，线程切换也是操作系统说了算，好处就是编程的时候比较正常，缺点就是进行线程的切换是要耗费资源的，而且新开线程也需要资源。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZGJhcGx1cy5jbi91cGxvYWRmaWxlLzIwMTYvMDgxMi8yMDE2MDgxMjEwMTcxNjgyMS5qcGc=.jpg"></p>
<p>有什么办法把这两种模型结合起来呢？我觉得golang的协程就是干了这个事情，golang的协程模型如下，这个图是我自己画的，主要是为了说明协程把上面两个模型结合，实际的协程模型长得不是这样子的啊。我们看到只剩下一个线程（或者进程）在CPU上跑了，上面的任务都跑到线程内部变成一个一个的代码片段了，执行哪个片段由线程内部决定，当遇到系统调用的时候，不用切换进程，而是直接切换执行其他的代码片段，这样的话，和线程模型比少了线程切换的开销，并且还能和回调模型一样，当IO操作的时候运行其他代码片段，最重要的是没有回调函数了，在开发人员看来和线程一样了。<br />
 </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZGJhcGx1cy5jbi91cGxvYWRmaWxlLzIwMTYvMDgxMi8yMDE2MDgxMjEwMTcyNjI2OS5qcGc=.jpg"></p>
<p>好了，关键问题来了，怎么调度的呢？上面的回调模型和线程模型调度的时候都是操作系统来完成的，这里就显示出代码内部的显示调用了，就是说这些代码片段运行的时候，运行一段时间后，通过调用一个函数，主动放弃CPU，这些个代码片段就像下面这样：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZGJhcGx1cy5jbi91cGxvYWRmaWxlLzIwMTYvMDgxMi8yMDE2MDgxMjEwMTczNjcwOC5wbmc=.jpg"></p>
<p>这就是代码内部的显示调用了，所谓协程嘛，就是需要运行的代码来协助进行任务的调度，怎么协助呢？就是显示的调用一个函数来进行现场保存和切换代码。很多人说我在写golang的时候没看到这玩意啊，恩，为了让你编程容易，这东西隐藏到系统调用中去了，就是说你在协程中只要进行了系统调用(比如打印系统，读取文件，操作网络)，那么在调用类似fmt.Println的时候就调用了这个调度函数来切换协程了，当然，你也可以在你的代码中主动放弃CPU使用权，只要调用runtime.Gosched()就行了。</p>
<p>关于这部分，你可以试试下面的代码，在单核CPU的情况下，第二个函数是永远执行不了的，如果是按照多线程的思想，第二个函数是可以执行的，这就是因为第一个函数没有系统调用没有IO操作，所以一直把持着CPU不放弃，这也是协程编程需要注意的地方。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZGJhcGx1cy5jbi91cGxvYWRmaWxlLzIwMTYvMDgxMi8yMDE2MDgxMjEwMTc0NzI4OS5wbmc=.jpg"></p>
<p>好了，协程的原理说了一下，我们再看看到底什么模型比较合适呢？我们看到，golang的协程这么设计出来，首先建立协程的消耗很少，并且在多IO操作的时候比线程是要占优势的，因为在IO操作的时候，只是像回调一样换了一段代码来执行，没有线程的切换。这也是为什么用golang来写服务器代码比较合适的原因，因为服务端的代码基本上都少不了IO操作，网络读写是IO，数据库读写是IO，这样用golang既可以保持原来的多线程编程的连贯思维，又可以尽可能的使用事件模型的优势，减少线程切换。</p>
<p>恩，现在回到我们的缓存，虽然我们在对缓存读写的时候没有IO操作，但是网络读写还是IO操作，而且对于缓存的操作本身理论上并不耗费多少时间（就是几个哈希操作），所以IO时间占比还是比较大的，所以这种情况下我觉得使用奔放的协程模式是可以的，但也别太奔放了，最好限制一下协程的数量。</p>
<p>但对于有些系统，比如搜索系统，广告系统这种服务，每次都有个在线排序的过程，这是个非常大计算量的任务，基本上一次请求80%的时间都耗费在排序这种计算上了，IO反而不是瓶颈，这种情况下，多线程模型和golang这种协程模型差别就不是很大了，这时候8核CPU只启动8个协程和启80个协程，效率的差别就不大了。</p>
<h2>5总结</h2>
<p>代码没准备好，不过放心不会太监的。这一篇没想到会这么长，后面有一段是写网络模型的，和缓存本身的关系不大，只是写到那里就想到了这个问题，多写了一些，那一段是我自己的理解，肯定有不对的地方，欢迎讨论拍砖。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 11:48:48</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/%e6%80%a7%e8%83%bd/" title="性能">性能</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e7%bb%84/" title="数组">数组</a>, <a href="https://www.iamivan.net/tag/%e7%ba%bf%e7%a8%8b/" title="线程">线程</a>, <a href="https://www.iamivan.net/tag/%e5%a4%9a%e7%ba%bf%e7%a8%8b/" title="多线程">多线程</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e7%bb%93%e6%9e%84/" title="数据结构">数据结构</a>, <a href="https://www.iamivan.net/tag/redis/" title="redis">redis</a>, <a href="https://www.iamivan.net/tag/golang/" title="Golang">Golang</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>从0开始打造一个独立内存的缓存系统的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlmZXqp.html" rel="bookmark">Bootstrap打造一个左侧折叠菜单的系统模板&lpar;一&rpar;&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 前言 最近需要做一个后台管理系统,我打算使用bootstrap弄一个好看的后台模板.网上的好多模板我觉的css和js有点重. 于是就打算完全依靠bootstrap搭建一个属于自己的模板. 首先从左侧的折叠菜单开始.看图. 2. CSS 代码 以下是自定义的css代码,由于系统是内部使用,所以优先考虑chrome,firefox 不考虑IE了. #main-nav { margin-left: 1px; } #main-nav.nav-tabs.nav-stacked &gt; li &gt; a {			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn8dXWb.html" rel="bookmark">Bootstrap打造一个左侧折叠菜单的系统模板&lpar;二&rpar;&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在上一篇文章给大家介绍了Bootstrap打造一个左侧折叠菜单的系统模板(一),具体内容介绍可以点击了解详情. 1. 关于上一篇文章BUG 上一篇文章中有几位朋友提出的问题和BUG. 我简单的说一下. 1&gt;. IE版本的支持? 我写的这些只是测试火狐谷歌浏览.在IE8+下可以添加代码以实现兼容. &lt;!--[if lt IE 9]&gt; &lt;script src=&quot;http://cdn.bootcss.com/html5shiv/3.7.2/html5shiv.min.js&qu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkGk87p.html" rel="bookmark">Memcached分布式内存对象缓存系统简单的使用过程分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				风信网(ithov.com)原创文章:Memcached是一套分布式内存对象缓存系统,用于在动态系统中减少数据库负载,进而提升系统性能.Memcached在很多时候都作为数据库的前端cache使用,因为它比数据库少了很多SQL解析.磁盘操作等开销,而且使用内存来管理数据,所以它可以提供比直接读取数据库更好的性能.另外,Memcached也经常作为服务器之间数据共享的存储媒介.学习完本章,相信读者能够对Memcached有一个全面的了解,使构建一套属于自己的分布式内存对象缓存系统变成很简单的事情.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBGa7kM.html" rel="bookmark">Memcached分布式内存对象缓存系统的性能监控</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				风信网(ithov.com)原创文章:本文将从三个方面向你介绍Memcached分布式内存对象缓存系统的管理与http://www.aliyun.com/zixun/aggregation/14216.html&quot;&gt;性能监控,主要的内容涉如何管理Memcached,如何监控Memcached及随着Memcached应用不断衍生出来的各变种产品的介绍. 如何管理Memcached 1．通过Memcached的监听端口进行管理 Memcached的管理相对比较容易,通过命令行登录到Memcach			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEJyJ9M.html" rel="bookmark">用F&num;从0开始打造一个大数据处理平台&lpar;1&period;整体规划&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这一大系列博客将介绍一个伟大的大数据处理平台是如何诞生的. 预计会有很多很多篇,持续很长很长时间. 为什么说 &quot;伟大&quot; 呢? 因为这将打造一整个新的体系. 不同于现有的大数据生态圈里各种产品的新的函数式体系结构.  数据处理本是函数式语言的专长, (比如Map 和 Reduce 是所有函数式语言的最重要的两个基础函数---哪怕在某些语言中不叫这两个名字), 无奈Hadoop 根植于jvm, 来源于Java,带动整个社区生态从hdfs, hbase, zookeeper, spark 以			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJeyBJp.html" rel="bookmark">怎样打造一个用户贡献内容的系统引擎</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				中介交易 SEO诊断 淘宝客 云主机 技术大厅 像Dribbble/Instagram/Vine等创意类内容平台都采用典型的UGC模式,但怎样才能打造一个比较良好的用户贡献内容的系统引擎?Sangeet Paul Choudary是专栏作家,也当过一些创业公司的顾问,他认为可以从以下几方面去思考这个问题: 如果没有用户贡献内容那平台就像死亡之城,毫无生机.内容创造者则是平台上很重要的角色,创业公司要打造出一个充满生机的平台就需要做好三件事:1. 弄清楚这个平台上的内容创造者的动机是什么; 2.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ba78Qmp.html" rel="bookmark">从0开始打造一个最小系统的数据库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本篇趟个雷,把数据库纳入到轮子中,在我看来,数据库比轮子复杂多了,是一个和操作系统差不多复杂度的东西,所以才能通过一个Oracle养活一家全球50强的公司.本文为后端轮子系列的第一篇,我们先来谈谈如何造个数据库吧. 先来聊聊关系型数据库 关系型数据库(Relational Database)是一个伟大的发明,一般的数据库理论,大概会分成以下三个部分. 首先,数据库是建立在关系模型基础上的,并且从理论上来讲,是有完备的数学模型,也就是集合代数来做支撑的,他把我们真实世界中的联系和实体抽象成了关系模			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/aM69vYb.html" rel="bookmark">ASP&colon;用ASP打造一个小型的网页BBS系统</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				传统的网页BBS大多是采用CGI模式实现的,它的实现要求编程者既要掌握编程语言如Perl或C等,又要了解关于CGI模式的各项技术内容,因此要制作自己的网页BBS确实困难不小.ASP(Active Server Pages 动态服务器主页)的出现,使我们眼前一亮,能不能利用ASP实现网页BBS呢?回答当然是肯定的.ASP的诱人之处就在于它提供了一种简单易学的脚本,并带有许多内置的对象,从而提供了一条简捷的编程之路. 该BBS主要由用户注册(浏览器端).用户注册(服务器端).加帖子(浏览器端).加帖			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/VMrQWyb.html" rel="bookmark">实例分析：用ASP打造一个小型的网页BBS系统</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				网页 传统的网页BBS大多是采用CGI模式实现的,它的实现要求编程者既要掌握编程语言如Perl或C等,又要了解关于CGI模式的各项技术内容,因此要制作自己的网页BBS确实困难不小.ASP(Active Server Pages 动态服务器主页)的出现,使我们眼前一亮,能不能利用ASP实现网页BBS呢?回答当然是肯定的.ASP的诱人之处就在于它提供了一种简单易学的脚本,并带有许多内置的对象,从而提供了一条简捷的编程之路. 该BBS主要由用户注册(浏览器端).用户注册(服务器端).加帖子(浏览器端)			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM91PVM.html" rel="bookmark" class="title">Linux中安装字体</a>
					<div>
						1. 获取字体文件 网上下载,或者从Windows的C:/Windows/Fonts目录下获取字体文件.ttf.我这里是consolo字体. 2. 建立新的字体目录 在Linux的/usr/share ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0boDBDM.html" rel="bookmark" class="title">如何为用户设置密码</a>
					<div>
						 当初次在机器上安装完Mysql时,你可以匿名进行访问数据库或者以不带口令的root身份进入数据库.另外如果你是一个管理员, 你还要进行一些用户的建立及授权,这又涉及到设置密码的问题.下面我们就讨论一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZORJ6b.html" rel="bookmark" class="title">Ruby on Rails导航菜单自动生成的方法</a>
					<div>
						最近在做的一个ROR的web项目中遇到如下问题: 产品可以按类分类导航浏览,主要可以分为A,B,C三类,三类之下还有其他分类,同时,基类和其下 的分类都可以由用户扩展.从横向上,主类可以由用户扩展,纵 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAa03KM.html" rel="bookmark" class="title">Windows Phone中ListBox在WP8能载入数据在WP7&period;x不能的问题</a>
					<div>
						首先,wp8和wp7.8的模拟器上都是运行着同一个程序 主页的任务就是 读取背景里那个类作为数据源的那个Note那个类然后显示在主页的listbox上 如图 2个模拟器都添加了一个项 而且都能正确显示 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1R06dp.html" rel="bookmark" class="title">笔记本Win7省电诀窍用Win7管理好电源</a>
					<div>
						你有没有在重要会议期间或长途飞行中发现Win7笔记本电池没电了?即使使用的是新技术,单次充电的便携式计算机也只能持续这么久.现在您可能已经有办法确保自己的Win7本本始终有电,比如您带有备用电池或电源 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVwaWnb.html" rel="bookmark" class="title">photoshop打不开图片怎么办&quest;</a>
					<div>
						  1.我们使用Photo CS4打开一张图片,出现&quot;无法完成请求,因为程序错误&quot;的对话框,可以单击编辑--首选项--性能,打开性能界面将内存调大,勾选其他暂存盘尝试. 如果上述办 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3EPOp.html" rel="bookmark" class="title">Adobe InDesign CS6如何置入多页pdf</a>
					<div>
						  1.打开Adobe InDesign CS6 2.新建&quot;文档&quot; 3.点击&quot;窗口&quot;,&quot;实用程序&quot;,&quot;脚本&quot;,也可以按住 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boRLqXz.html" rel="bookmark" class="title">苹果新专利：双屏电子书设备 支持体感操控</a>
					<div>
						7 月 30 日消息,美国专利商标局今天公布了苹果新获得的一项技术专利,这项新专利与电子书设备相关.根据苹果在专利文件中的透露,他们发明了一种拥有两个显示屏幕的电子书设备,两个屏幕分别位于设备的前后方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdExG3z.html" rel="bookmark" class="title">wpf dll和exe合并成一个新的exe</a>
					<div>
						原文:wpf dll和exe合并成一个新的exe 微软有一个工具叫ILMerge可以合并dll exe等,但是对于wpf的应用程序而言这个工具就不好用了.我的这方法也是从国外一个博客上找来的.仅供大家 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4N5m9M.html" rel="bookmark" class="title">Vim编程之：tags&comma;cscope&comma;taglist</a>
					<div>
						最近VIM用得比较多,所以在学了不少.在这里对收获到的东西做一个总结. 1.编程四要素vim,ctags,cscope,taglist vim配合这3件东西之后,极为强大.与SourceInsight ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4NLVLM.html" rel="bookmark" class="title">视频的容器与格式 &period;</a>
					<div>
						转发自: http://blog.csdn.net/tttyd/article/details/6893392   1.视频容器格式简介    一般而言,视频文件的扩展名就是视频的容器名.比如&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJkyLqb.html" rel="bookmark" class="title">javascript-js如何将两个值模糊匹配  像sql的like进行判断</a>
					<div>
						问题描述 js如何将两个值模糊匹配 像sql的like进行判断 var str1 ; var str2; if(//这进行str1和str2的判断){ return true: }else{ retu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXwJBWM.html" rel="bookmark" class="title">如何使用open watcom c&sol;c&plus;&plus;进行编程？？</a>
					<div>
						问题描述 如何使用open watcom c/c++进行编程?? 如何使用open watcom c/c++进行编程?? 刚刚安装了open watcom c/c++,但不会用,求会用的赐教,最好有一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV093BM.html" rel="bookmark" class="title">阿里感悟（八）-如何才能加入阿里？</a>
					<div>
						进入阿里有两种途径,校招和社招.下面我会分别介绍下校招和社招的流程和基本要求,最后分享几个面试小窍门. 校招的流程.一般提前一年就开始了,需要应届生留意下阿里的招聘官网和官方微博.校招是由集团统一管理 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKndBb.html" rel="bookmark" class="title">小心阅读模式下的猫腻&mdash;&mdash;看看我如何在Edge的阅读模式下绕过SOP</a>
					<div>
						本文讲的是小心阅读模式下的猫腻--看看我如何在Edge的阅读模式下绕过SOP, Microsoft Edge全新的浏览器让人眼前一亮,而阅读模式可以说是其中的亮点之一.不过今天我们并不是要评价它的这个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Zryaz.html" rel="bookmark" class="title">青云QingCloud宣布第六次资费下调 最高降幅达10&percnt;</a>
					<div>
						北京,2016年7月14日-- 企业级基础云服务商青云QingCloud(qingcloud.com)日前宣布,自7月14日零时起对公有云部分资源进行资费下调,最高下调幅度达10%.今年是QingCl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MydJ3Eb.html" rel="bookmark" class="title">谁能解决下啊</a>
					<div>
						问题描述 Loading .tld files from global classpath[17:39:29.077] {http--8080-10$16724745} java.lang.Illeg ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOmDxQM.html" rel="bookmark" class="title">socket-new 一个Socket 出来，是不是Socket的源代码已经包括基础输入输出流了</a>
					<div>
						问题描述 new 一个Socket 出来,是不是Socket的源代码已经包括基础输入输出流了 DataOutputStream dos = new DataOutputStream(s.getOutp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVQZqBp.html" rel="bookmark" class="title">Linux&lowbar;CentOS-服务器搭建 &amp;lt&semi;六&amp;gt&semi;</a>
					<div>
						修改MySQL编码: 二话不说先登录: mysql -u root -p 查看下神奇的mysql系统变量及其值: show variables like '%character%'; //记住分号哦, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLDqRM.html" rel="bookmark" class="title">vb-求VB脚本，arcgis脚本</a>
					<div>
						问题描述 求VB脚本,arcgis脚本 NAME字段属性为&quot;北京-天津站&quot;,怎样取值为&quot;北天站&quot;,求教高人啊,一直写不成的 解决方案 http://blog.s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDnLyvM.html" rel="bookmark" class="title">ios 微信 qq sdk-微信SDK可以获取到好友列表么？添加好友呢？QQ查询好友列表和添加好友呢？</a>
					<div>
						问题描述 微信SDK可以获取到好友列表么?添加好友呢?QQ查询好友列表和添加好友呢? 问题如题!凑字(...................................). 解决方案 不能,不会开 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M12nq8p.html" rel="bookmark" class="title">应届毕业生找不到工作，是不是就要去培训啊</a>
					<div>
						问题描述 应届毕业生找不到工作,是不是就要去培训啊 解决方案 解决方案二:用人单位不要你无非就是2种原因1.这人招进来会把我公司毁了2.我花更少的代价也能招到和你一样的人解决方案三:参加培训说明这个人 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRNW6GM.html" rel="bookmark" class="title">Oracle 数据类型定义</a>
					<div>
						Oracle数据类型 定义 CHAR &lt;=2000 DATE Jan 1, 4712 B.C.到 Dec 31, 4712 A.D. DECIMAL 同 Number一样 FLOAT 同 Num ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwByOM.html" rel="bookmark" class="title">proxool的问题</a>
					<div>
						问题描述 我使用的是proxool0.83在proxool.xml中设置的&lt;maximum-connection-count&gt;10&lt;/maximum-connection-count ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBg8ykM.html" rel="bookmark" class="title">java-分层开发模式，分层架构</a>
					<div>
						问题描述 分层开发模式,分层架构 问:? 10 分层开发模式那个分层开发,Sql语句是写在数据库访问层还是说写在业务逻辑层然后将语句传到数据库访问层?或者说是将实体传到数据库访问层,在数据库访问层编写 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoO2xM.html" rel="bookmark" class="title">mysql hash 索引 vs B-TREE 索引</a>
					<div>
						Terry Tsang //我相信最有价值的东西,是很多人都应该因为它而一起学习和进步的!真正有价值的技术,都是值得和所有人分享的! hash 索引 当前 memory 引擎, innodb 引擎支持 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKqXOap.html" rel="bookmark" class="title">欧锦赛即将展开巅峰对决</a>
					<div>
						漫画铁勋 7月2日凌晨2点45分,欧锦赛势头强劲的意大利队与夺冠大热西班牙队即将展开巅峰对决. 万里之外的宁波海曙,35岁的张军(化名)正守在电视机前等待最后的结果. 张军在意的并不是球赛本身,而是球 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV776Qb.html" rel="bookmark" class="title">2010年搜索引擎优化发展趋势</a>
					<div>
						谷歌曾以它的Caffeine来回应Bing,自从去年Florida更新后,较大的基础设施也随之有了改变.Matts在他的博客上回答到: 真正的变化将于明年1月份之后公布于众,2010年是他与DCs的第 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr2554M.html" rel="bookmark" class="title">Jquery Ajax的Get方式时需要注意URL地方&lowbar;jquery</a>
					<div>
						提示:我们要时刻注意浏览器缓存, 当使用GET方式时要添加时间戳参数 (net Date()).getTime() 来保证每次发送的URL不同, 可以避免浏览器缓存. 提示: 当在url参数后面添加了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlAVqVp.html" rel="bookmark" class="title">tp link 802&period;11n无线网络安全：64位密钥的WEP加密</a>
					<div>
						tp link 802.11n无线网络安全之64位密钥的WEP加密配置方法:WEP加密配置第一步:tp link 802.11n套装中路由器型号为TL-WR841N,我们通过默认管理地址192.168 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.037 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
